<?php
// Module Info

// The name of this module
define("_MI_PROTECTOR_NAME","Xoops Protector");

// A brief description of this module
define("_MI_PROTECTOR_DESC","This module protects your xoops site from various attacks like DoS , SQL Injection , and Variables contaminations.<br />\nYou should put this block in top of left blocks and edit all groups can access this block.");

// Names of blocks for this module (Not all module has blocks)
define("_MI_PROTECTOR_BNAME1","Protector");
define("_MI_PROTECTOR_BDESC1","This block should be put in top of left blocks and should be displayed against 'all pages'.");

// Menu
define("_MI_PROTECTOR_ADMININDEX","Protect Center");
define("_MI_PROTECTOR_ADVISORY","Security Advisory");
define("_MI_PROTECTOR_MYBLOCKSADMIN","Blocks&Groups Admin");

// Configs
define('_MI_PROTECTOR_DIE_BADEXT','Exit if bad files are uploaded');
define('_MI_PROTECTOR_DIE_BADEXTDSC','If someone tries to upload files which have bad extensions like .php , this module exits your XOOPS.<br />If you often attach php files into B-Wiki or PukiWikiMod, turn this off.');
define('_MI_PROTECTOR_DIE_CONTAMI','Exit if contaminations found');
define('_MI_PROTECTOR_DIE_CONTAMIDSC','If someone tries to contaminate system global variables into your XOOPS, this module exits your XOOPS.<br />(recommended as ON)');
define('_MI_PROTECTOR_BIP_CONTAMI','Register as Bad IP by contaminations');
define('_MI_PROTECTOR_BIP_CONTAMIDSC','When someone tries to attack by contamination, this module registers his/her IP as "Ban IP" of system preferences automatically.');
define('_MI_PROTECTOR_SAN_ISOCOM','Force sanitizing isolated comment-in');
define('_MI_PROTECTOR_SAN_ISOCOMDSC','When isolated "/*" is found, this module append "*/" into the post data.<br />This option is highly recommended if your prefix of db is "xoops" same as default.');
define('_MI_PROTECTOR_DIE_ISOCOM','Exit if isolated comment-in found');
define('_MI_PROTECTOR_DIE_ISOCOMDSC','When isolated "/*" is found, this module exits your XOOPS.<br />This option protects you from almost attacks of SQL Injection.');
define('_MI_PROTECTOR_BIP_ISOCOM','Register as Bad IP by isolated comment-in');
define('_MI_PROTECTOR_BIP_ISOCOMDSC','When isolated "/*" is found, this module registers his/her IP as "Ban IP" of system preferences automatically. (recommended as Off)');
define('_MI_PROTECTOR_SAN_UNION','Force sanitizing union');
define('_MI_PROTECTOR_SAN_UNIONDSC','When some syntax like UNION of SQL, this module changes "union" of the post data to "uni-on".<br />This option is highly recommended if your prefix of db is "xoops" same as default.');
define('_MI_PROTECTOR_DIE_UNION','Exit if union found');
define('_MI_PROTECTOR_DIE_UNIONDSC','When some syntax like UNION of SQL, this module exits your XOOPS.<br />This option protects you from some kind of attacks of SQL Injection.');
define('_MI_PROTECTOR_BIP_UNION','Register as Bad IP by union');
define('_MI_PROTECTOR_BIP_UNIONDSC','When some syntax like UNION of SQL, this module registers his/her IP as "Ban IP" of system preferences automatically. (recommended as Off)');
define('_MI_PROTECTOR_ID_INTVAL','Force intval to variables like id');
define('_MI_PROTECTOR_ID_INTVALDSC','All requests named "*id" will be treated as integer.<br />This option protects you from some kind of XSS and SQL Injections.<br />Though I recommend to turn this option on, it can cause problems with some modules.');
define('_MI_PROTECTOR_FILE_DOTDOT','Patch doubtful file specifications');
define('_MI_PROTECTOR_FILE_DOTDOTDSC','It eliminates ".." from all requests looks like specifying files');

define('_MI_PROTECTOR_DOS_EXPIRE','Watch time for high loadings (sec)');
define('_MI_PROTECTOR_DOS_EXPIREDSC','This value specifies the watch time for high-frequent reloading (F5 attack) and high loading crawlers.');

define('_MI_PROTECTOR_DOS_F5COUNT','Bad counts for F5 Attack');
define('_MI_PROTECTOR_DOS_F5COUNTDSC','Preventing from DoS attacks.<br />This value specifies the reloading counts to be considered as a malicious attack.');
define('_MI_PROTECTOR_DOS_F5ACTION','Action against F5 Attack');

define('_MI_PROTECTOR_DOS_CRCOUNT','Bad counts for Crawlers');
define('_MI_PROTECTOR_DOS_CRCOUNTDSC','Preventing from high loading crawlers.<br />This value specifies the access counts to be considered as a bad-manner crawler.');
define('_MI_PROTECTOR_DOS_CRACTION','Action against high loading Crawlers');

define('_MI_PROTECTOR_DOS_CRSAFE','Welcomed User-Agent');
define('_MI_PROTECTOR_DOS_CRSAFEDSC','A perl regex pattern for User-Agent.<br />If it matches, the crawler is never considered as a high loading crawler.<br />eg) /(msnbot|Googlebot|Yahoo! Slurp)/i');

define('_MI_PROTECTOR_DOSOPT_NONE','None (only logging)');
define('_MI_PROTECTOR_DOSOPT_SLEEP','Sleep');
define('_MI_PROTECTOR_DOSOPT_EXIT','Blank Screen');
define('_MI_PROTECTOR_DOSOPT_BIP','Ban the IP');

define('_MI_PROTECTOR_BIP_EXCEPT','Groups never registered as Bad IP');
define('_MI_PROTECTOR_BIP_EXCEPTDSC','A user who belongs to the group specified here will never be banned.<br />(I recommend to turn Administrator on.)');
define('_MI_PROTECTOR_PASSWD_BIP','Rescue password (disabling ban IP)');
define('_MI_PROTECTOR_PASSWD_BIPDSC','If you are banned out from your own site, access XOOPS_URL/modules/protector/admin/rescue.php and input this password.<br />Don\'t forget setting the password before you are banned out by some mistakes.<br />If this option is blank, the script disabling ban IP will never work.');

?>